<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" />
    <!--<link rel="apple-touch-icon" sizes="76x76" href="assets/img/apple-icon.png">-->
    <!--<link rel="icon" type="image/png" href="assets/img/favicon.ico">-->
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
    <title>Dashboard</title>
    <meta content='width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0, shrink-to-fit=no' name='viewport' />
    <!--     Fonts and icons     -->
    <link href="https://fonts.googleapis.com/css?family=Montserrat:400,700,200" rel="stylesheet" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/latest/css/font-awesome.min.css" />
    <!-- CSS Files -->
    <link href="assets/css/bootstrap.min.css" rel="stylesheet" />
    <link href="assets/css/light-bootstrap-dashboard.css?v=2.0.1" rel="stylesheet" />
    <link href="assets/css/jquery-ui.css" rel="stylesheet">
</head>

<body>
    <div class="wrapper">
        <div class="sidebar" data-image="assets/img/sidebar-2.jpg" data-color="red">
            <div class="sidebar-wrapper" >
                <ul class="nav">
                    <li class="nav-item active">
                        <a class="nav-link" href="dashboard.html">
                            <i class="nc-icon nc-chart-pie-35"></i>
                            <p>Dashboard</p>
                        </a>
                    </li>
                </ul>
            </div>
        </div>
        <div class="main-panel">
            <!-- Navbar -->
            <nav class="navbar navbar-expand-lg " color-on-scroll="500">
                <div class=" container-fluid  ">
                    <a class="navbar-brand" href="https://www.titoma.com"> <img src="assets/img/TITOMA-Logo.png" alt="TITOMA" width=100 height=60> </a>
                    <div class="collapse navbar-collapse justify-content-end" id="navigation">
                        <ul class="nav navbar-nav mr-auto">
                            <li class="nav-item">
                                <a href="#" class="nav-link" data-toggle="dropdown">
                                    <i class="nc-icon nc-palette"></i>
                                    <span class="d-lg-none">Dashboard</span>
                                </a>
                            </li>
                            <li class="dropdown nav-item">
                                <a href="#" class="dropdown-toggle nav-link" data-toggle="dropdown">
                                    <i class="nc-icon nc-planet"></i>
                                    <span class="notification">5</span>
                                    <span class="d-lg-none">Notification</span>
                                </a>
                                <ul class="dropdown-menu">
                                    <a class="dropdown-item" href="#">Notification 1</a>
                                    <a class="dropdown-item" href="#">Notification 2</a>
                                    <a class="dropdown-item" href="#">Notification 3</a>
                                    <a class="dropdown-item" href="#">Notification 4</a>
                                    <a class="dropdown-item" href="#">Another notification</a>
                                </ul>
                            </li>
                            <li class="nav-item">
                                <a href="#" class="nav-link">
                                    <i class="nc-icon nc-zoom-split"></i>
                                    <span class="d-lg-block">&nbsp;Search</span>
                                </a>
                            </li>
                        </ul>
                        <ul class="navbar-nav ml-auto">
                            <li class="nav-item">
                                <a class="sign-data nav-link" href="#pablo">
                                    <span id="google-user" class="no-icon"></span>
                                </a>
                            </li>
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" href="http://example.com" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    <span class="no-icon">Options</span>
                                </a>
                                <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                                   
                                    <a class="dropdown-item" href="#" onclick="exportTableToExcel('timesheet-table')">Export to excel</a>
                                    <div class="divider"></div>
                                    <a class="dropdown-item sign-data" href="#pablo">
                                        <span class="no-icon" onclick="signOut();">Log out</span>
                                    </a> 
                                </div>
                            </li>
                            <li class="nav-item">
                                <div class="g-signin2" data-onsuccess="onSignIn"></div>

                            </li>
                        </ul>
                    </div>
                </div>
            </nav>
            <!-- End Navbar -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <div class="col-md-12">
                            <div id="timesheet-card" class="card ">
                                <div class="card-header ">
                                    <h4 class="card-title">Timesheet</h4>
                                    <p class="card-category"> Today </p>
                                </div>
                                <div class="card-body ">
                                    <div class="form-group">
                                      <label for="initial_date_select">Initial date:</label>
                                      <input id="initial_date_select" style="color: #205527;" class="form-control datepicker">
                                      </input>
                                    </div>
                                    <div class="form-group">
                                      <label for="final_date_select">Final date:</label>
                                      <input id="final_date_select" style="color: #205527;" class="form-control datepicker">
                                      </input>
                                    </div>
                                    <div class="table-responsive">
<!--                                           <table id="timesheet-table" class="table" style="table-layout:fixed; width:100%;">
-->                                   <table id="timesheet-table" class="table table-scrolling">
                                        <tbody>
                                          <tr>
                                            <td> 
                                            </td>
                                            <td>
                                            </td>
                                            <td> 
                                            </td>
                                            <td> 
                                            </td>
                                          </tr>
                                        </tbody>
                                      </table>
                                    </div>
                                </div>
                                <div class="card-footer ">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <footer class="footer">
                <div class="container">
                    <nav>
                        <ul class="footer-menu">
                            <li>
                                <a href="#">
                                    Home
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    Company
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    Portfolio
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    Blog
                                </a>
                            </li>
                        </ul>
                        <p class="copyright text-center">
                            ©
                            <script>
                                document.write(new Date().getFullYear())
                            </script>
                            <a href="http://www.creative-tim.com">Creative Tim</a>, made with love for a better web
                        </p>
                    </nav>
                </div>
            </footer>
        </div>
    </div>
</body>


<!--   Core JS Files   -->
<script src="assets/js/core/jquery.3.2.1.min.js" type="text/javascript"></script>
<script src="assets/js/core/jquery-ui.js"></script>
<script src="assets/js/core/popper.min.js" type="text/javascript"></script>
<script src="assets/js/core/bootstrap.min.js" type="text/javascript"></script>
<!--  Plugin for Switches, full documentation here: http://www.jque.re/plugins/version3/bootstrap.switch/ -->
<script src="assets/js/plugins/bootstrap-switch.js"></script>
<!--  Chartist Plugin  -->
<script src="assets/js/plugins/chartist.min.js"></script>
<!--  Notifications Plugin    -->
<script src="assets/js/plugins/bootstrap-notify.js"></script>
<!-- Moment plugin -->
<script src="assets/js/plugins/moment.min.js"></script>
<!-- Sroll table plugin -->
<script src="assets/js/plugins/jquery.scroll-table-body-1.0.0.js"></script>
<!-- Control Center for Light Bootstrap Dashboard: scripts for the example pages etc -->
<script src="assets/js/light-bootstrap-dashboard.js?v=2.0.1" type="text/javascript"></script>
<!-- Light Bootstrap Dashboard DEMO methods, don't include it in your project! -->
<script src="assets/js/demo.js"></script>
<!-- MQTT client! -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/paho-mqtt/1.0.1/mqttws31.min.js" type="text/javascript"></script>

<script src="https://sdk.amazonaws.com/js/aws-sdk-2.283.1.min.js"></script>

<script src="https://apis.google.com/js/platform.js" async defer></script>

<meta name="google-signin-client_id" content="66260623813-utml1fmgpmcecdgbbbu33ec8nnrjjviq.apps.googleusercontent.com">

<script src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/3.1.9-1/crypto-js.min.js"></script>

<script src="assets/js/plugins/bootstrap-select.js"></script>


<!-- Ajax client to send requests with authentication  -->
<script src="assets/js/ajax-client.js"></script>
<!-- sha256 signature -->
<script src="assets/js/hmac-sha256.js"></script>

<script type="text/javascript">

    function onSignIn(googleUser) {
        $(".sign-data").css("display","block");
        $("#timesheet-card").css("display","block");
        document.getElementById("google-user").innerText = googleUser.getBasicProfile().getName()
        client = demo.MQTTConnect();

    }

    function signOut() {
      var auth2 = gapi.auth2.getAuthInstance();
      auth2.signOut().then(function () {
        client.disconnect();
        $(".sign-data").css("display","none");
        $("#timesheet-card").css("display","none");
/*            $("#initial_date_select").off('change');
        $("#final_date_select").off('change');
        $("#timesheet-table").remove();*/
        alert('Successfully signed out.');
      });
    }

    function exportTableToExcel(table_id, filename = ''){
        var download_link;
        var data_type = 'application/vnd.ms-excel';
        var table_select = document.getElementById(table_id);
        var table_HTML = table_select.outerHTML.replace(/ /g, '%20');
        
        // Specify file name
        filename = filename?filename+'.xls':'excel_data.xls';
        
        // Create download link element
        download_link = document.createElement("a");
        
        document.body.appendChild(download_link);
        
        if(navigator.msSaveOrOpenBlob){
            var blob = new Blob(['\ufeff', table_HTML], {
                type: data_type
            });
            navigator.msSaveOrOpenBlob( blob, filename);
        }else{
            // Create a link to the file
            download_link.href = 'data:' + data_type + ', ' + table_HTML;
        
            // Setting the file name
            download_link.download = filename;
            
            //triggering the function
            download_link.click();
        }
    }

    $(document).ready(function() {


        $(".datepicker").datepicker();
        $(".table").on("scroll", function () {
            $("table > *").width($("table").width() + $("table").scrollLeft());
        });

/*        $("table").scrollTableBody({rowsToDisplay:20});
*/
        function applyDelay(date, delays){
          for (delay_index in delays){
            delay = delays[delay_index];
            if (delay != 0){
              switch (delay_index){
                case "0":
                  date.setFullYear(date.getFullYear() + delay);
                  break;
                case "1":
                  date.setMonth(date.getMonth() + delay);
                  break;
                case "2":
                  date.setDate(date.getDate() + delay);
                  break;
                case "3":
                  date.setHours(date.getHours() + delay);
                  break
                case "4":
                  date.setMinutes(date.getMinutes() + delay);
                  break;
                default:
                  break;
              }
            }
          }
          return date
        }

        function getTime(delays=[0,0,0,0,0]){ //[years,months,days,hours,minutes]
            var date = new Date()
            date = applyDelay(date, delays)
            var month = date.getMonth() + 1;
            var year = date.getFullYear();
            var day = date.getDate();
            var hour = date.getHours();
            var minute = date.getMinutes();
            return {"year": year,
                  "month": month,
                  "day": day,
                  "hour": hour,
                  "minute": minute }
        }

        var signclient = ajaxSignClient.newClient({
            accessKey: 'AKIAJ47NADEHKGA4EMFQ',
            secretKey: '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',
            sessionToken: '',
            serviceName: 'execute-api',
            region: 'us-east-2',
            apiKey: '',
            endpoint: 'https://cq3on7a4uk.execute-api.us-east-2.amazonaws.com'
        });

        function requestData(path, queryParams, callback, ...args){
            var signedRequest = signclient.ajaxSignedRequest({
                verb: 'GET',
                path: '/develop' + path + '/',
                queryParams: queryParams,
                body: {},
                headers: {
                  "x-api-key": signclient.config.apiKey
                }
            });

            $.ajax({
                url: signedRequest.url,
                type: signedRequest.method,
                contentType: 'application/x-www-form-urlencoded',
                data: signedRequest.data,
                headers: signedRequest.headers,
                success: function (data, status, request) { 
                  callback(data, args);
                },
                failure: function () {
                  console.log("error");
                }
            });
        }


        today = getTime();
        $("#initial_date_select").val(today['month'] + '/' + today['day'] + '/' + today['year']);
        $("#initial_date_select").change(fillInTable);
        $("#final_date_select").val(today['month'] + '/' + today['day'] + '/' + today['year']);
        $("#final_date_select").change(fillInTable);

        function fillInTable(){

            $("#timesheet-table tr>td").remove();

            initial_selected_date = $("#initial_date_select").val().split('/');
            initial_selected_year = initial_selected_date[2];
            initial_selected_month = initial_selected_date[0];
            initial_selected_day = initial_selected_date[1];
            final_selected_date = $("#final_date_select").val().split('/');
            final_selected_year = final_selected_date[2];
            final_selected_month = final_selected_date[0];
            final_selected_day = final_selected_date[1];

            min_selected_date = new Date(initial_selected_year, initial_selected_month - 1, initial_selected_day, 0,0);
            max_selected_date = new Date(final_selected_year, final_selected_month - 1, final_selected_day, 23,59);

            min_date = initial_selected_year + '-' + initial_selected_month + '-' + initial_selected_day + "-00:00";
            max_date = final_selected_year + '-' + final_selected_month + '-' + final_selected_day + "-23:59";
            queryParams = {
              "min_date": min_date,
              "max_date": max_date
            }
            requestData('/by-interval', queryParams, fillInTimesheet, min_selected_date, max_selected_date);                  
        }

        function getDayOfWeekAsString(day_index) {
            return ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"][day_index];
        }

        function fillInTimesheet(employee_data, dates){

            var timesheet_table = document.getElementById('timesheet-table');
            min_date = dates[0];
            max_date = dates[1];
            dates = {};
            range = 0;
            while (min_date <= max_date){
                min_date_timestamp = min_date.getTime()/1000;
                min_date.setDate(min_date.getDate() + 1);
                next_date_timestamp = min_date.getTime()/1000;
                dates[range] = [min_date_timestamp, next_date_timestamp];
                range ++;            
            }

            var header = timesheet_table.createTHead();
            var row = header.insertRow(0);
            row.style.color = '#9A9A9A';
            var cell_name = row.insertCell(0);
            cell_name.innerText = 'EMPLOYEE';

            var days_num = Object.keys(dates).length;
            for (var day = 0; day < days_num; day++){
                var cell_type = row.insertCell(1);
                var cell_time = row.insertCell(2);
                var cell_total = row.insertCell(3);
                cell_total.style.fontWeight = "bold";
                cell_total.style.color = 'red';
                cell_type.innerHTML = 'TYPE';
                cell_total.innerHTML = 'TOTAL';
                date = new Date(parseFloat(dates[days_num - day - 1][0])*1000);
                cell_time.innerHTML =  getDayOfWeekAsString(date.getDay()) + '-' + (date.getDate()<10?'0':'') + date.getDate();
            }
            var cell_big_total = row.insertCell(days_num*3+1);
            cell_big_total.style.fontWeight = "bold";
            cell_big_total.innerHTML = 'BIG TOTAL';
             
            

            for (employee_name in employee_data){

                requests = employee_data[employee_name];
                requests_per_day = {};
                num_request_per_day = [];
                for (request_index in requests){
                    request = requests[request_index];
                    request_type = request['request_type'];
                    request_time = request['request_time'];
                    for (var day = 0; day < Object.keys(dates).length; day++){
                        if (!requests_per_day[day]){ requests_per_day[day] = []; num_request_per_day[day] = 0;}
                        range = dates[day];
                        if (parseInt(request_time) >= range[0] && parseInt(request_time) < range[1]){
                            requests_per_day[day].push(request);
                            num_request_per_day[day]++;
                        }
                    }
                }
                max_num_request_per_day = Math.max(...num_request_per_day);

                for (var index = 0; index < max_num_request_per_day; index++){
                    var row = timesheet_table.insertRow(1);
                    var cell_name = row.insertCell(0);
                    if (index == max_num_request_per_day - 1 ){
                        cell_name.innerHTML = employee_name; 
                    }else{
                        cell_name.innerHTML = ''; 
                    }               
                }

                var total_working_hours = 0;
                var days_in_employee_requests = Object.keys(requests_per_day).length
                for (var day = 0; day < days_in_employee_requests; day++){

                    requests = requests_per_day[day];
                    total_working_hours_per_day = 0;
                    partial_working_hours = 0;
                    out_request_flag = true;
                    in_request_flag = false;

                    for (var index = 0; index < max_num_request_per_day; index++){
                        var row = timesheet_table.rows[index + 1]; 
                        var cell_type = row.insertCell(day*3 + 1);
                        var cell_time = row.insertCell(day*3 + 2);
                        if (requests[index]){
                            request = requests[index];
                            request_time = request['request_time'];
                            request_type = request['request_type'];
                            request_date = new Date(parseFloat(request_time)*1000);
                            cell_type.innerHTML = request_type;
                            cell_time.innerHTML = (request_date.getHours()<10?'0':'') + request_date.getHours() + ':' + (request_date.getMinutes()<10?'0':'') + request_date.getMinutes();
                            //cell_time.innerHTML = request_time;
                            if (request_type == 'IN' && in_request_flag){
                                out_request_flag = true;
                                partial_working_hours = (out_request_time - parseInt(request_time))/3600;   
                            }else{
                                if (request_type == 'OUT' && out_request_flag){
                                    out_request_flag = false;
                                    in_request_flag = true;
                                    out_request_time = parseInt(request_time);
                                    total_working_hours_per_day += partial_working_hours;
                                }    
                            }
                          
                        }else{
                            cell_type.innerHTML = '';
                            cell_time.innerHTML = '';
                        }
                        
                    }
                    for (var index = 0; index < max_num_request_per_day; index++){
                        var row_total = timesheet_table.rows[index+1];
                        var cell_total = row_total.insertCell(day*3 + 3);
                        if (index == 0){
                            total_working_hours_per_day += partial_working_hours;
                            total_working_hours += total_working_hours_per_day;
                            if (total_working_hours_per_day){
                                cell_total.innerHTML = Math.round(total_working_hours_per_day*100)/100;
                            }else{
                                cell_total.innerHTML = 'N/A';
                            }
                        }else{
                           cell_total.innerHTML = ''; 
                        }
                    }
                }

                for (var index = 0; index < max_num_request_per_day; index++){
                    var row_big_total = timesheet_table.rows[index + 1];
                    var cell_big_total = row_big_total.insertCell(days_in_employee_requests*3 + 1);
                    if (index == 0 ){
                        cell_big_total.innerHTML = Math.round(total_working_hours*100)/100; 
                    }else{
                        cell_big_total.innerHTML = ''; 
                    }               
                }
            }
        }

        
    });

</script>

</html>